#!/usr/bin/python

def diag (fid, data, perm):
    if not perm: perm = range(0,100)
    out.write('beginfig(%d);\n' % fid)
    out.write('  setup;')
    n = len(data)
    for k in range(0,n):
        if (k % 3 == 0) and (k < n): out.write('\n ')
        i,t = data[k]
        out.write(' dot(%9.5f,%3d);' % (t,perm[i]))
    out.write('\nendfig;\n\n')

if __name__ == '__main__':
    with open('dotdisp.mp', 'w') as out:
        out.write('w := 0.1mm;\n\n')
        out.write('vardef setup =\n')
        out.write('  pickup pensquare xscaled 1pt yscaled 1pt;\n')
        out.write('  draw unitsquare xscaled (200mm+2pt) '
                                   +'yscaled (100mm+1pt)\n')
        out.write('  shifted (-0.5pt,-0.5pt);\n')
        out.write('  label.urt("neurons", (0, 0.8mm)) rotated 90;\n')
        out.write('  label.lrt("time",    (0,-0.7mm));\n')
        out.write('  pickup pensquare xscaled w yscaled 0.67mm;\n')
        out.write('enddef;\n\n');
        out.write('vardef dot (expr x, y) =\n')
        out.write('  drawdot(x*1mm+0.5w,y*1mm+0.5mm) withcolor blue;\n')
        out.write('enddef;\n\n');

        sync = sorted([ 4,  5, 11, 22, 24, 28, 29, 30, 32, 39,
                       40, 50, 54, 60, 69, 80, 82, 83, 88, 93])
        sync = [i-1 for i in sync]
        sync = sync + sorted(set(range(0,100)) -set(sync))
        perm = dict([(sync[i],i) for i in range(0,100)])

        with open('../../data/file1.gdf', 'r') as inp:
            data = [line.rstrip('\n\r').split() for line in inp]
        data = [(int(i)-1,0.02*float(t)) for i,t in data]
        diag(0, data, [])

        with open('../../data/file2.gdf', 'r') as inp:
            data = [line.rstrip('\n\r').split() for line in inp]
        data = [(int(i)-1,0.02*float(t)) for i,t in data]
        diag(1, data, [])
        diag(2, data, perm)

        with open('../../data/file3.gdf', 'r') as inp:
            data = [line.rstrip('\n\r').split() for line in inp]
        data = [(int(i)-1,0.02*float(t)) for i,t in data]
        diag(3, data, [])
        diag(4, data, perm)

        out.write('end.')
